procedure TGLZMatrix4.Multiply(constref M2: TGLZMatrix4);
begin
  Self.X.X:=Self.X.X*M2.X.X+Self.X.Y*M2.Y.X+Self.X.Z*M2.Z.X+Self.X.W*M2.W.X;
  Self.X.Y:=Self.X.X*M2.X.Y+Self.X.Y*M2.Y.Y+Self.X.Z*M2.Z.Y+Self.X.W*M2.W.Y;
  Self.X.Z:=Self.X.X*M2.X.Z+Self.X.Y*M2.Y.Z+Self.X.Z*M2.Z.Z+Self.X.W*M2.W.Z;
  Self.X.W:=Self.X.X*M2.X.W+Self.X.Y*M2.Y.W+Self.X.Z*M2.Z.W+Self.X.W*M2.W.W;

  Self.Y.X:=Self.Y.X*M2.X.X+Self.Y.Y*M2.Y.X+Self.Y.Z*M2.Z.X+Self.Y.W*M2.W.X;
  Self.Y.Y:=Self.Y.X*M2.X.Y+Self.Y.Y*M2.Y.Y+Self.Y.Z*M2.Z.Y+Self.Y.W*M2.W.Y;
  Self.Y.Z:=Self.Y.X*M2.X.Z+Self.Y.Y*M2.Y.Z+Self.Y.Z*M2.Z.Z+Self.Y.W*M2.W.Z;
  Self.Y.W:=Self.Y.X*M2.X.W+Self.Y.Y*M2.Y.W+Self.Y.Z*M2.Z.W+Self.Y.W*M2.W.W;

  Self.Z.X:=Self.Z.X*M2.X.X+Self.Z.Y*M2.Y.X+Self.Z.Z*M2.Z.X+Self.Z.W*M2.W.X;
  Self.Z.Y:=Self.Z.X*M2.X.Y+Self.Z.Y*M2.Y.Y+Self.Z.Z*M2.Z.Y+Self.Z.W*M2.W.Y;
  Self.Z.Z:=Self.Z.X*M2.X.Z+Self.Z.Y*M2.Y.Z+Self.Z.Z*M2.Z.Z+Self.Z.W*M2.W.Z;
  Self.Z.W:=Self.Z.X*M2.X.W+Self.Z.Y*M2.Y.W+Self.Z.Z*M2.Z.W+Self.Z.W*M2.W.W;

  Self.W.X:=Self.W.X*M2.X.X+Self.W.Y*M2.Y.X+Self.W.Z*M2.Z.X+Self.W.W*M2.W.X;
  Self.W.Y:=Self.W.X*M2.X.Y+Self.W.Y*M2.Y.Y+Self.W.Z*M2.Z.Y+Self.W.W*M2.W.Y;
  Self.W.Z:=Self.W.X*M2.X.Z+Self.W.Y*M2.Y.Z+Self.W.Z*M2.Z.Z+Self.W.W*M2.W.Z;
  Self.W.W:=Self.W.X*M2.X.W+Self.W.Y*M2.Y.W+Self.W.Z*M2.Z.W+Self.W.W*M2.W.W;
end;

procedure TGLZMatrix4.Transpose; assembler;
asm
{$ifdef CPU64}
  {$ifdef UNIX}
    movups   xmm0, DQWORD[RDI + 00]
    movups   xmm1, DQWORD[RDI + $10]
    movups   xmm2, DQWORD[RDI + $20]
    movups   xmm3, DQWORD[RDI + $30]
 {$else}
    movups   xmm0, DQWORD[RCX + 00]  // A03 A02 A01 A00
    movups   xmm1, DQWORD[RCX + $10] // A13 A12 A11 A10
    movups   xmm2, DQWORD[RCX + $20] // A23 A22 A21 A20
    movups   xmm3, DQWORD[RCX + $30] // A33 A32 A31 A30
 {$endif}
{$else}
  movups   xmm0, DQWORD[ECX + 00]
  movups   xmm1, DQWORD[ECX + $10]
  movups   xmm2, DQWORD[ECX + $20]
  movups   xmm3, DQWORD[ECX + $30]
{$endif}

  movaps   xmm4, xmm2
  unpcklps xmm2, xmm3               // A31 A21 A30 A20
  unpckhps xmm4, xmm3               // A33 A23 A32 A22

  movaps   xmm3, xmm0
  unpcklps xmm0, xmm1               // A11 A01 A10 A00
  unpckhps xmm3, xmm1               // A13 A03 A12 A02

  movaps   xmm1, xmm0
  unpcklpd xmm0, xmm2               // A30 A20 A10 A00
  unpckhpd xmm1, xmm2               // A31 A21 A11 A01

  movaps   xmm2, xmm3
  unpcklpd xmm2, xmm4               // A32 A22 A12 A02
  unpckhpd xmm3, xmm4               // A33 A23 A13 A03

  {$ifdef CPU64}
    {$ifdef UNIX}
      movups   DQWORD[RDI + $00], xmm0
      movups   DQWORD[RDI + $10], xmm1
      movups   DQWORD[RDI + $20], xmm2
      movups   DQWORD[RDI + $30], xmm3
   {$else}
     movups   DQWORD[RCX + $00], xmm0
     movups   DQWORD[RCX + $10], xmm1
     movups   DQWORD[RCX + $20], xmm2
     movups   DQWORD[RCX + $30], xmm3
   {$endif}
  {$else}
    movups   DQWORD[ECX + $00], xmm0
    movups   DQWORD[ECX + $10], xmm1
    movups   DQWORD[ECX + $20], xmm2
    movups   DQWORD[ECX + $30], xmm3
  {$endif}
end;


