class operator TNativeGLZVector4f.+(constref A, B: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result.X := A.X + B.X;
  Result.Y := A.Y + B.Y;
  Result.Z := A.Z + B.Z;
  Result.W := A.W + B.W;
end;

class operator TNativeGLZVector4f.-(constref A, B: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result.X := A.X - B.X;
  Result.Y := A.Y - B.Y;
  Result.Z := A.Z - B.Z;
  Result.W := A.W - B.W;
end;

class operator TNativeGLZVector4f.*(constref A, B: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result.X := A.X * B.X;
  Result.Y := A.Y * B.Y;
  Result.Z := A.Z * B.Z;
  Result.W := A.W * B.W;
end;

class operator TNativeGLZVector4f./(constref A, B: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result.X := A.X / B.X;
  Result.Y := A.Y / B.Y;
  Result.Z := A.Z / B.Z;
  Result.W := A.W / B.W;
end;

class operator TNativeGLZVector4f.+(constref A: TNativeGLZVector4f; constref B:Single): TNativeGLZVector4f;
begin
  Result.X := A.X + B;
  Result.Y := A.Y + B;
  Result.Z := A.Z + B;
  Result.W := A.W + B;
end;

class operator TNativeGLZVector4f.-(constref A: TNativeGLZVector4f; constref B:Single): TNativeGLZVector4f;
begin
  Result.X := A.X - B;
  Result.Y := A.Y - B;
  Result.Z := A.Z - B;
  Result.W := A.W - B;
end;

class operator TNativeGLZVector4f.*(constref A: TNativeGLZVector4f; constref B:Single): TNativeGLZVector4f;
begin
  Result.X := A.X * B;
  Result.Y := A.Y * B;
  Result.Z := A.Z * B;
  Result.W := A.W * B;
end;

class operator TNativeGLZVector4f./(constref A: TNativeGLZVector4f; constref B:Single): TNativeGLZVector4f;
begin
  Result.X := A.X / B;
  Result.Y := A.Y / B;
  Result.Z := A.Z / B;
  Result.W := A.W / B;
end;

class operator TNativeGLZVector4f.-(constref A : TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result.X := -A.X;
  Result.Y := -A.Y;
  Result.Z := -A.Z;
  Result.W := -A.W;
end;

class operator TNativeGLZVector4f.=(constref A, B: TNativeGLZVector4f): Boolean;
begin
  Result := (A.X = B.X) and (A.Y = B.Y) and (A.Z = B.Z) and (A.W = B.W);
end;

class operator TNativeGLZVector4f.>=(constref A, B: TNativeGLZVector4f): Boolean;
begin
  Result := (A.X >= B.X) and (A.Y >= B.Y) and (A.Z >= B.Z) and (A.W >= B.W);
end;

class operator TNativeGLZVector4f.<=(constref A, B: TNativeGLZVector4f): Boolean;
begin
  Result := (A.X <= B.X) and (A.Y <= B.Y) and (A.Z <= B.Z) and (A.W <= B.W);
end;

class operator TNativeGLZVector4f.>(constref A, B: TNativeGLZVector4f): Boolean;
begin
  Result := (A.X > B.X) and (A.Y > B.Y) and (A.Z > B.Z) and (A.W > B.W);
end;

class operator TNativeGLZVector4f.<(constref A, B: TNativeGLZVector4f): Boolean;
begin
  Result := (A.X < B.X) and (A.Y < B.Y) and (A.Z < B.Z) and (A.W < B.W);
end;

class operator TNativeGLZVector4f.<>(constref A, B: TNativeGLZVector4f): Boolean;
begin
  Result := (A.X <> B.X) and (A.Y <> B.Y) and (A.Z <> B.Z) and (A.W <> B.W);
end;

function TNativeGLZVector4f.Abs:TNativeGLZVector4f;
begin
  result.X:=System.Abs(Self.X);
  result.Y:=System.Abs(Self.Y);
  result.Z:=System.Abs(Self.Z);
  result.W:=System.Abs(Self.W);
End;

function TNativeGLZVector4f.Negate:TNativeGLZVector4f;
begin
  Result:=Self;
  Result.X := -Result.X;
  Result.Y := -Result.Y;
  Result.Z := -Result.Z;
  Result.W := -Result.W;
end;

function TNativeGLZVector4f.DivideBy2 : TNativeGLZVector4f;
begin
  Result.x := Self.X*0.5;
  Result.y := Self.Y*0.5;
  Result.z := Self.Z*0.5;
  Result.w := Self.W*0.5;
end;

function TNativeGLZVector4f.Distance(constref A: TNativeGLZVector4f):Single;
begin
  result := sqrt(sqr(Self.X-A.X)+ sqr(Self.Y-A.Y) + sqr(Self.Z-A.Z));
end;

function TNativeGLZVector4f.Length : Single;
//var
//X1 : Single;
begin
  Result := Sqrt((Self.X * Self.X) +(Self.Y * Self.Y) +(Self.Z * Self.Z));
  { Ensure result is non-zero to avoid divide-by-zero errors }
  //if X1 = 0 then X1 := 0.0000000001;
  //Result := X1;
end;

function TNativeGLZVector4f.DotProduct(constref A: TNativeGLZVector4f) : Single;
var
 V2:TNativeGLZVector4f;
begin
  V2.X := Self.X*A.X;
  V2.Y := Self.Y*A.Y;
  V2.Z := Self.Z*A.Z;
  //V2.W := Self.W*A.W;
  Result := V2.X + V2.Y + V2.Z;// + V2.W;
end;

function TNativeGLZVector4f.CrossProduct(constref A: TNativeGLZVector4f
  ): TNativeGLZVector4f;
begin
  result.X:=Self.Y*A.Z-Self.Z*A.Y;
  result.Y:=Self.Z*A.X-Self.X*A.Z;
  result.Z:=Self.X*A.Y-Self.Y*A.X;
  result.W:=1;
end;

function TNativeGLZVector4f.Norm : Single;
var v2:TNativeGLZVector4f;
begin
  v2.x := Self.X*Self.X;
  v2.y := Self.Y*Self.Y;
  v2.z := Self.Z*Self.Z;
  v2.w := Self.W*Self.W;
  Result := v2.X + v2.Y + v2.Z; //+ v2.w;
end;

function TNativeGLZVector4f.Normalize : TNativeGLZVector4f;
var
  invLen : Single;
  vn : single;
begin
  vn:=Self.Norm;
  if vn=0 then
  begin
    result := Self;
    result.W := 0; //cZero;
  end
  else
  begin
    invLen:=1/Sqrt(vn);
    result.X:=Self.X*invLen;
    result.Y:=Self.Y*invLen;
    result.Z:=Self.Z*invLen;
    result.W:=Self.W;
  end;
end;

function TNativeGLZVector4f.Min(constref B: Single): TNativeGLZVector4f;
begin
  Result := Self;
  if Self.X>B then Result.X := B;
  if Self.Y>B then Result.Y := B;
  if Self.Z>B then Result.Z := B;
  if Self.W>B then Result.W := B;
End;

function TNativeGLZVector4f.Min(constref B: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result := Self;
  if Self.X>B.X then Result.X := B.X;
  if Self.Y>B.Y then Result.Y := B.Y;
  if Self.Z>B.Z then Result.Z := B.Z;
  if Self.W>B.W then Result.W := B.W;
End;

function TNativeGLZVector4f.Max(constref B: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result := Self;
  if Self.X<B.X then Result.X := B.X;
  if Self.Y<B.Y then Result.Y := B.Y;
  if Self.Z<B.Z then Result.Z := B.Z;
  if Self.W<B.W then Result.W := B.W;
End;

function TNativeGLZVector4f.Max(constref B: Single): TNativeGLZVector4f;
begin
  Result := Self;
  if Self.X<B then Result.X := B;
  if Self.Y<B then Result.Y := B;
  if Self.Z<B then Result.Z := B;
  if Self.W<B then Result.W := B;
End;

function TNativeGLZVector4f.Clamp(Constref AMin, AMax: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  Result := Self.Max(AMin);
  Result := Result.Min(AMax);
End;

function TNativeGLZVector4f.Clamp(constref AMin, AMax: Single): TNativeGLZVector4f;
begin
  Result := Self.Max(AMin);
  Result := Result.Min(AMax);
End;

function TNativeGLZVector4f.MulAdd(Constref B, C: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  result := (self*B)+C;
end;

function TNativeGLZVector4f.MulDiv(Constref B, C: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  result := (self*B)/C;
end;

function TNativeGLZVector4f.Lerp(Constref B: TNativeGLZVector4f; Constref T:Single): TNativeGLZVector4f;
begin
   Result.X:=Self.X+(B.X-Self.X)*t;
   Result.Y:=Self.Y+(B.Y-Self.Y)*t;
   Result.Z:=Self.Z+(B.Z-Self.Z)*t;
   Result.W := Self.W;
end;

function TNativeGLZVector4f.AngleCosine(constref A: TNativeGLZVector4f): Single;
begin
   Result:=Self.DotProduct(A)/(Self.Length*A.Length);
end;

function TNativeGLZVector4f.AngleBetween(Constref A, ACenterPoint : TNativeGLZVector4f): Single;
Var
  vt1,vt2  :  TNativeGLZVector4f;
begin
  vt1 := Self - ACenterPoint;
  vt2 := A - ACenterPoint;
  vt1.pNormalize;
  vt2.pNormalize;
  Result := ArcCos(vt1.AngleCosine(vt2));
end;

function TNativeGLZVector4f.Combine(constref V2: TNativeGLZVector4f; constref F1: Single): TNativeGLZVector4f;
begin
  Result.X:=Self.X+v2.X*F1;
  Result.Y:=Self.Y+v2.Y*F1;
  Result.Z:=Self.Z+v2.Z*F1;
//  Result.W:=Self.W+v2.W*F1;
  Result.W:=0;
End;

function TNativeGLZVector4f.Combine2(constref V2: TNativeGLZVector4f; const F1, F2: Single): TNativeGLZVector4f;
begin
   Result.X:=( Self.X*F1) + (V2.X*F2);
   Result.Y:=( Self.Y*F1) + (V2.Y*F2);
   Result.Z:=( Self.Z*F1) + (V2.Z*F2);
   Result.W:=0;
end;

function TNativeGLZVector4f.Combine3(constref V2, V3: TNativeGLZVector4f; const F1, F2, F3: Single): TNativeGLZVector4f;
begin
  Result.X:=( Self.X*F1) + (V2.X*F2) + (V3.X*F3);
  Result.Y:=( Self.Y*F1) + (V2.Y*F2) + (V3.Y*F3);
  Result.Z:=( Self.Z*F1) + (V2.Z*F2) + (V3.Z*F3);
  Result.W:=0;
end;

function TNativeGLZVector4f.Perpendicular(constref N : TNativeGLZVector4f) : TNativeGLZVector4f;
var
   dot : Single;
begin
   dot:=Self.DotProduct(N);
   Result.X:=Self.X-Dot * Self.X;
   Result.Y:=Self.Y-Dot * Self.Y;
   Result.Z:=Self.Z-Dot * Self.Z;
   Result.W:=0;
end;

function TNativeGLZVector4f.Reflect(constref N: TNativeGLZVector4f): TNativeGLZVector4f;
begin
  //  Result:=Self.Combine(Self, N, 1, -2*VectorDotProduct(Self, N));
  Result := Self - (N*(2 * N.Dotproduct(Self)));
 // Result.W:=0;
end;

procedure TNativeGLZVector4f.pAdd(constref A: TNativeGLZVector4f);
begin
  Self.X := Self.X + A.X;
  Self.Y := Self.Y + A.Y;
  Self.Z := Self.Z + A.Z;
  Self.W := Self.W + A.W;
end;

procedure TNativeGLZVector4f.pSub(constref A: TNativeGLZVector4f);
begin
  Self.X := Self.X - A.X;
  Self.Y := Self.Y - A.Y;
  Self.Z := Self.Z - A.Z;
  Self.W := Self.W - A.W;
end;

procedure TNativeGLZVector4f.pMul(constref A: TNativeGLZVector4f);
begin
  Self.X := Self.X * A.X;
  Self.Y := Self.Y * A.Y;
  Self.Z := Self.Z * A.Z;
  Self.W := Self.W * A.W;
end;

procedure TNativeGLZVector4f.pDiv(constref A: TNativeGLZVector4f);
begin
  Self.X := Self.X / A.X;
  Self.Y := Self.Y / A.Y;
  Self.Z := Self.Z / A.Z;
  Self.W := Self.W / A.W;
end;

procedure TNativeGLZVector4f.pAdd(constref A: Single);
begin
  Self.X := Self.X + A;
  Self.Y := Self.Y + A;
  Self.Z := Self.Z + A;
  Self.W := Self.W + A;
end;

procedure TNativeGLZVector4f.pSub(constref A: Single);
begin
  Self.X := Self.X - A;
  Self.Y := Self.Y - A;
  Self.Z := Self.Z - A;
  Self.W := Self.W - A;
end;

procedure TNativeGLZVector4f.pMul(constref A: Single);
begin
  Self.X := Self.X * A;
  Self.Y := Self.Y * A;
  Self.Z := Self.Z * A;
  Self.W := Self.W * A;
end;

procedure TNativeGLZVector4f.pDiv(constref A: Single);
begin
  Self.X := Self.X / A;
  Self.Y := Self.Y / A;
  Self.Z := Self.Z / A;
  Self.W := Self.W / A;
end;

procedure TNativeGLZVector4f.pInvert;
begin
  Self.X := -Self.X;
  Self.Y := -Self.Y;
  Self.Z := -Self.Z;
  Self.W := -Self.W;
end;

procedure TNativeGLZVector4f.pNegate;
begin
   Self.X := -Self.X;
   Self.Y := -Self.Y;
   Self.Z := -Self.Z;
   Self.W := -Self.W;
end;

procedure TNativeGLZVector4f.pAbs;
begin
  Self.X:=System.Abs(Self.X);
  Self.Y:=System.Abs(Self.Y);
  Self.Z:=System.Abs(Self.Z);
  Self.W:=System.Abs(Self.W);
End;

procedure TNativeGLZVector4f.pDivideBy2;
begin
  Self.x := Self.X*0.5;
  Self.y := Self.Y*0.5;
  Self.z := Self.Z*0.5;
  Self.w := Self.W*0.5;
end;

procedure TNativeGLZVector4f.pCrossProduct(constref A: TNativeGLZVector4f);
Var
 Tmp : TNativeGLZVector4f;
begin
  Tmp.X:=Self.Y*A.Z-Self.Z*A.Y;
  Tmp.Y:=Self.Z*A.X-Self.X*A.Z;
  Tmp.Z:=Self.X*A.Y-Self.Y*A.X;
  Tmp.W:=1;
  Self := Tmp;
end;

procedure TNativeGLZVector4f.pNormalize;
var
  invLen : Single;
  vn : single;
begin
  vn:=Self.Norm;
  if vn=0 then
  begin
//    result := Self;
    Self.W := 0; //cZero;
  end
  else
  begin
    invLen:=1/Sqrt(vn);
    Self.X:=Self.X*invLen;
    Self.Y:=Self.Y*invLen;
    Self.Z:=Self.Z*invLen;
    Self.W:=Self.W;
  end;
end;

procedure TNativeGLZVector4f.pMin(constref B: TNativeGLZVector4f);
begin
  if Self.X>B.X then Self.X := B.X;
  if Self.Y>B.Y then Self.Y := B.Y;
  if Self.Z>B.Z then Self.Z := B.Z;
  if Self.W>B.W then Self.W := B.W;
End;

procedure TNativeGLZVector4f.pMin(constref B: Single);
begin
  if Self.X>B then Self.X := B;
  if Self.Y>B then Self.Y := B;
  if Self.Z>B then Self.Z := B;
  if Self.W>B then Self.W := B;
End;

procedure TNativeGLZVector4f.pMax(constref B: TNativeGLZVector4f);
begin
  if Self.X<B.X then Self.X := B.X;
  if Self.Y<B.Y then Self.Y := B.Y;
  if Self.Z<B.Z then Self.Z := B.Z;
  if Self.W<B.W then Self.W := B.W;
End;

procedure TNativeGLZVector4f.pMax(constref B: Single);
begin
  if Self.X<B then Self.X := B;
  if Self.Y<B then Self.Y := B;
  if Self.Z<B then Self.Z := B;
  if Self.W<B then Self.W := B;
End;

procedure TNativeGLZVector4f.pClamp(Constref AMin, AMax: TNativeGLZVector4f);
begin
  Self.Max(AMin);
  Self.Min(AMax);
End;

procedure TNativeGLZVector4f.pClamp(constref AMin, AMax: Single);
begin
  Self.Max(AMin);
  Self.Min(AMax);
End;

procedure TNativeGLZVector4f.pMulAdd(Constref B, C: TNativeGLZVector4f); // (Self*B)+c
begin
  Self := (self*B)+C;
end;

procedure TNativeGLZVector4f.pMulDiv(Constref B, C: TNativeGLZVector4f); // (Self*B)-c
begin
  Self := (self*B)/C;
end;
